%-------------------------------------------------------------------
% lecture des donnes d'apprentissage
load A_data.txt -ascii 
X=A_data(:,1);         % vecteur des observations en entre
Y=A_data(:,2);         % vecteur des observations en sortie
figure(1);
plot(X,Y,'+');         
xlabel('Entre X');
ylabel('Sortie Y');
title('Donnes d''apprentissage');	

%-------------------------------------------------------------------
% Cration du rseau avec 1 neurone d'entre, 2 neurones cachs 
% et 1 neurone de sortie linaire
net = mlp(1,2, 1, 'linear');                            

%-------------------------------------------------------------------
% Rglages des options de l'algorithme d'optimisation
options = zeros(1,18); % vecteur nul de taille 18
options(1) = 1;        % affiche l'erreur totale  chaque itration
options(14) = 10;      % nombre maximum d'itrations 

%-------------------------------------------------------------------
% Optimisation avec un algorithme quasi-newton
[net, options, errors] = netopt(net, options, X, Y, 'quasinew');

%-------------------------------------------------------------------
% Affichage du critre des moindres carrs en fonction des itrations
figure(2);        
semilogy(errors);
xlabel('Itrations');
ylabel('Critre des moindres carrs');
title('Optimisation des poids du rseau');	

%-------------------------------------------------------------------
% Comparaison de la sortie du rseau et des donnes
figure(3);           
XT=[-2:0.01:2]';     % vecteur d'entre de test
YT=mlpfwd(net,XT);   % calcul de la sortie de test
plot(X,Y,'+',XT,YT);
xlabel('Entre X');
ylabel('Sortie Y');
title('Comparaison de la sortie du rseau avec les donnes');	

%-------------------------------------------------------------------
% Calcul de la valeur finale du critre des moindres carrs pour les 
% donnes d'apprentissage
Crit_data=mlperr(net,X,Y)
